#include <vcl.h>
#pragma hdrstop

// self
#include "formMain.h"

// vcl-stub
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

// ----------------------------------------------------------------------------
// Definition
// ----------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) :
   TForm(Owner)
{
   chart_->OnBeforeDrawSeries = OnBeforeDrawSeries;

   DrawDiagram();
}

// functional
void TForm1::DrawDiagram(void)
{
   chart_->RemoveAllSeries();

   TLineSeries* const series = new TLineSeries(chart_);
   series->Color = clYellow;
   series->LinePen->Style = psDot;
   series->Pointer->Style = psNothing;
   series->Pointer->Visible = true;
   series->OnGetPointerStyle = OnGetPointerStyle;

   double dp = 0.5;
   double q0 = 50.0;

   for(double t0 = 0; t0 < 60; ++t0)
   {
      dp = dp + 0.1;
      q0 = q0 + 100.0;

      series->AddXY(dp, q0);
   }

   chart_->AddSeries(series);
}

// events
void __fastcall TForm1::OnBeforeDrawSeries(TObject* sender)
{
   if(TLineSeries* const lineSeries = dynamic_cast<TLineSeries*>(sender))
      lineSeries->LinePen->Style = psDot;
}

Teengine::TSeriesPointerStyle __fastcall TForm1::OnGetPointerStyle(Teengine::TChartSeries* sender, int valueIndex)
{
   TSeriesPointerStyle pointerStyle = TSeriesPointerStyle::psNothing;

   if(TLineSeries* const lineSeries = dynamic_cast<TLineSeries*>(sender))
   {
      lineSeries->LinePen->Style = psDot;

      if(valueIndex > 0)
      {
         double n = lineSeries->XValues->Items[valueIndex];
         if(n >= 1.5)
            lineSeries->LinePen->Style = psSolid;
      }
   }

   return pointerStyle;
}

